//--------------------------------------------------------------
// Press F1 to get help about using script.
// To access an object that is not located in the current class, start the call with Globals.
// When using events and timers be cautious not to generate memoryleaks,
// please see the help for more information.
//---------------------------------------------------------------

namespace Neo.ApplicationFramework.Generated
{
    using System.Windows.Forms;
    using System;
    using System.Drawing;
    using Neo.ApplicationFramework.Tools;
    using Neo.ApplicationFramework.Common.Graphics.Logic;
    using Neo.ApplicationFramework.Controls;
    using Neo.ApplicationFramework.Interfaces;
	
	using System.Net;
	using System.Net.Sockets;
	using System.Threading;
	using System.Text;
    
    public partial class UDPClientScript
	{
		public static EthClient ethClient = null;
		
		static UDPClientScript()
		{
			ethClient = new EthClient();
		}
		
		public static void Send(string outStr) 
		{
			if (ethClient == null) { return; }
			ethClient.Send(outStr);
		}
	}
	
	public class EthClient
	{
		private readonly IPAddress targetIP = new IPAddress(new byte[] {10,50,2,17});
		private readonly int targetPort = 2000;
		
		private UdpClient udpClient = null;
		private Thread clientThread = null;		
		
		public EthClient()
		{
			try {
				udpClient = new UdpClient();
				udpClient.Connect(targetIP, targetPort);
				clientThread = new Thread(new ThreadStart(DataReceive));
				clientThread.Start();
			}
			catch (Exception ex) {
				MessageBox.Show("EthClient(), " + ex.Message);
			}
		}
		
		private void DataReceive()
		{
			try {
				while (true) 
				{
					IPEndPoint remoteEP = new IPEndPoint(targetIP, 0);
					byte[] data = udpClient.Receive(ref remoteEP);
					Globals.Tags.Tag1.Value = new string(Encoding.Default.GetChars(data));
				}
			}
			catch (Exception ex) {
				MessageBox.Show("DataReceive(), " + ex.Message);
			}
		}
		
		public void Send(string outStr) 
		{
			try {
				if (udpClient == null) { return; }
				udpClient.Send(Encoding.Default.GetBytes(outStr), outStr.Length);
			}
			catch (Exception ex) {
				MessageBox.Show("Send(..), " + ex.Message);
			}
		}			
	}
}
